# database: forum


# browsing
DROP TABLE IF EXISTS browsing;

CREATE TABLE browsing(
    user_id VARCHAR(50) NOT NULL,
    username VARCHAR(255) NOT NULL,
    time BIGINT(50) UNSIGNED NOT NULL,
    ims TINYINT(1) NOT NULL,
    guest INT(11) NOT NULL,
    blocked BLOB NOT NULL,
    seq VARCHAR(50) NOT NULL
);

# evo_bans
DROP TABLE IF EXISTS evo_bans;

CREATE TABLE evo_bans(
    auto INT(11) NOT NULL AUTO_INCREMENT,
    ip VARCHAR(255) NOT NULL,
    type VARCHAR(20) NOT NULL,
    PRIMARY KEY (auto),
    INDEX auto (auto)
);

# evo_bookmarks
DROP TABLE IF EXISTS evo_bookmarks;

CREATE TABLE evo_bookmarks(
    auto INT(11) NOT NULL AUTO_INCREMENT,
    owner INT(11) NOT NULL,
    link VARCHAR(255) NOT NULL,
    time INT(100) NOT NULL,
    PRIMARY KEY (auto)
);

# evo_filter
DROP TABLE IF EXISTS evo_filter;

CREATE TABLE evo_filter(
    auto SMALLINT(6) NOT NULL AUTO_INCREMENT,
    filtered VARCHAR(255) NOT NULL,
    withwhat VARCHAR(255) NOT NULL,
    PRIMARY KEY (auto),
    UNIQUE auto_2 (auto),
    INDEX auto (auto)
);

# evo_forums
DROP TABLE IF EXISTS evo_forums;

CREATE TABLE evo_forums(
    auto INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
    fgroup INT(11) NOT NULL,
    title VARCHAR(255) NOT NULL,
    description BLOB NOT NULL,
    mods VARCHAR(100) NOT NULL,
    last VARCHAR(255) NOT NULL,
    views BIGINT(100) UNSIGNED NOT NULL,
    sub TINYINT(1) NOT NULL,
    rules VARCHAR(50) NOT NULL,
    type INT(1) NOT NULL,
    PRIMARY KEY (auto),
    UNIQUE auto_2 (auto),
    INDEX auto (auto)
);

# evo_groups
DROP TABLE IF EXISTS evo_groups;

CREATE TABLE evo_groups(
    auto INT(11) NOT NULL AUTO_INCREMENT,
    title VARCHAR(255) NOT NULL,
    PRIMARY KEY (auto),
    UNIQUE auto_2 (auto),
    INDEX auto (auto)
);

# evo_hmf
DROP TABLE IF EXISTS evo_hmf;

CREATE TABLE evo_hmf(
    header TEXT NOT NULL,
    meta TEXT NOT NULL,
    footer TEXT NOT NULL
);

# evo_news
DROP TABLE IF EXISTS evo_news;

CREATE TABLE evo_news(
    news BLOB NOT NULL
);

# evo_pms
DROP TABLE IF EXISTS evo_pms;

CREATE TABLE evo_pms(
    auto INT(11) NOT NULL AUTO_INCREMENT,
    owner INT(11) NOT NULL,
    author INT(11) NOT NULL,
    subject VARCHAR(255) NOT NULL,
    message BLOB NOT NULL,
    opened INT(11) NOT NULL,
    date INT(50) NOT NULL,
    PRIMARY KEY (auto)
);

# evo_poll
DROP TABLE IF EXISTS evo_poll;

CREATE TABLE evo_poll(
    auto INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
    name VARCHAR(255) NULL,
    o1 VARCHAR(50) NULL,
    o2 VARCHAR(50) NULL,
    o3 VARCHAR(50) NULL,
    o4 VARCHAR(50) NULL,
    o5 VARCHAR(50) NULL,
    v1 VARCHAR(50) NULL,
    v2 VARCHAR(50) NULL,
    v3 VARCHAR(50) NULL,
    v4 VARCHAR(50) NULL,
    v5 VARCHAR(50) NULL,
    voted BLOB NOT NULL,
    PRIMARY KEY (auto),
    UNIQUE auto_2 (auto),
    INDEX auto (auto)
);

# evo_posts_2
DROP TABLE IF EXISTS evo_posts_2;

CREATE TABLE evo_posts_2(
    topic_id BIGINT(255) UNSIGNED NOT NULL,
    post_id BIGINT(255) UNSIGNED NOT NULL AUTO_INCREMENT,
    poster_id INT(11) NOT NULL,
    post BLOB NOT NULL,
    time BIGINT(255) UNSIGNED NOT NULL,
    something TINYINT(4) NOT NULL,
    notify INT(1) NOT NULL,
    ip VARCHAR(100) NOT NULL,
    sig INT(1) NOT NULL,
    subject VARCHAR(255) NOT NULL,
    PRIMARY KEY (post_id),
    UNIQUE post_id_2 (post_id),
    INDEX post_id (post_id)
);

# evo_posts_3
DROP TABLE IF EXISTS evo_posts_3;

CREATE TABLE evo_posts_3(
    topic_id BIGINT(255) UNSIGNED NOT NULL,
    post_id BIGINT(255) UNSIGNED NOT NULL AUTO_INCREMENT,
    poster_id INT(11) NOT NULL,
    post BLOB NOT NULL,
    time BIGINT(255) UNSIGNED NOT NULL,
    something TINYINT(4) NOT NULL,
    notify INT(1) NOT NULL,
    ip VARCHAR(100) NOT NULL,
    sig INT(1) NOT NULL,
    subject VARCHAR(255) NOT NULL,
    PRIMARY KEY (post_id),
    UNIQUE post_id_2 (post_id),
    INDEX post_id (post_id)
);

# evo_posts_4
DROP TABLE IF EXISTS evo_posts_4;

CREATE TABLE evo_posts_4(
    topic_id BIGINT(255) UNSIGNED NOT NULL,
    post_id BIGINT(255) UNSIGNED NOT NULL AUTO_INCREMENT,
    poster_id INT(11) NOT NULL,
    post BLOB NOT NULL,
    time BIGINT(255) UNSIGNED NOT NULL,
    something TINYINT(4) NOT NULL,
    notify INT(1) NOT NULL,
    ip VARCHAR(100) NOT NULL,
    sig INT(1) NOT NULL,
    subject VARCHAR(255) NOT NULL,
    PRIMARY KEY (post_id),
    UNIQUE post_id_2 (post_id),
    INDEX post_id (post_id)
);

# evo_stars
DROP TABLE IF EXISTS evo_stars;

CREATE TABLE evo_stars(
    d1 INT(10) NOT NULL,
    d2 INT(10) NOT NULL,
    d3 INT(10) NOT NULL,
    d4 INT(10) NOT NULL,
    d5 INT(10) NOT NULL,
    d6 INT(10) NOT NULL
);

# evo_suspended
DROP TABLE IF EXISTS evo_suspended;

CREATE TABLE evo_suspended(
    ID INT(5) NOT NULL,
    RANK INT(5) NOT NULL
);

# evo_themes
DROP TABLE IF EXISTS evo_themes;

CREATE TABLE evo_themes(
    ID INT(2) NOT NULL AUTO_INCREMENT,
    NAME VARCHAR(10) NOT NULL,
    USED INT(1) NOT NULL,
    BGCOLOR VARCHAR(7) NOT NULL,
    TEXT VARCHAR(7) NOT NULL,
    LINK VARCHAR(7) NOT NULL,
    VLINK VARCHAR(7) NOT NULL,
    ALINK VARCHAR(7) NOT NULL,
    FONT_FACE VARCHAR(100) NOT NULL,
    FONT_SIZE INT(2) NOT NULL,
    TABLE_WIDTH CHAR(3) NOT NULL,
    TABLE1_COLOR VARCHAR(7) NOT NULL,
    TABLE2_COLOR VARCHAR(7) NOT NULL,
    TABLE_BORDER INT(1) NOT NULL,
    TABLE_HEADER VARCHAR(7) NOT NULL,
    POST_NEW VARCHAR(100) NOT NULL,
    POST_REPLY VARCHAR(100) NOT NULL,
    POST_REPLYCLOSED VARCHAR(100) NOT NULL,
    HEADER VARCHAR(100) NOT NULL,
    CSS TEXT NOT NULL,
    forumname VARCHAR(255) NOT NULL,
    headerfontcolor VARCHAR(7) NOT NULL,
    postpoll VARCHAR(255) NOT NULL,
    PRIMARY KEY (ID)
);

# evo_titles
DROP TABLE IF EXISTS evo_titles;

CREATE TABLE evo_titles(
    auto INT(11) NOT NULL AUTO_INCREMENT,
    start INT(11) NOT NULL,
    delimeter INT(11) NOT NULL,
    rank TINYINT(1) NOT NULL,
    INDEX auto (auto)
);

# evo_topics_2
DROP TABLE IF EXISTS evo_topics_2;

CREATE TABLE evo_topics_2(
    topic_id INT(11) NOT NULL AUTO_INCREMENT,
    topic_subject VARCHAR(255) NOT NULL,
    poster_id INT(11) NOT NULL,
    time BIGINT(255) UNSIGNED NOT NULL,
    audience INT(2) NOT NULL,
    views BIGINT(100) UNSIGNED NOT NULL,
    icon INT(1) NOT NULL,
    pollid INT(11) NOT NULL,
    readit BLOB NOT NULL,
    closed INT(1) NOT NULL,
    PRIMARY KEY (topic_id),
    UNIQUE topic_id_2 (topic_id),
    INDEX topic_id (topic_id)
);

# evo_topics_3
DROP TABLE IF EXISTS evo_topics_3;

CREATE TABLE evo_topics_3(
    topic_id INT(11) NOT NULL AUTO_INCREMENT,
    topic_subject VARCHAR(255) NOT NULL,
    poster_id INT(11) NOT NULL,
    time BIGINT(255) UNSIGNED NOT NULL,
    audience INT(2) NOT NULL,
    views BIGINT(100) UNSIGNED NOT NULL,
    icon INT(1) NOT NULL,
    pollid INT(11) NOT NULL,
    readit BLOB NOT NULL,
    closed INT(1) NOT NULL,
    PRIMARY KEY (topic_id),
    UNIQUE topic_id_2 (topic_id),
    INDEX topic_id (topic_id)
);

# evo_topics_4
DROP TABLE IF EXISTS evo_topics_4;

CREATE TABLE evo_topics_4(
    topic_id INT(11) NOT NULL AUTO_INCREMENT,
    topic_subject VARCHAR(255) NOT NULL,
    poster_id INT(11) NOT NULL,
    time BIGINT(255) UNSIGNED NOT NULL,
    audience INT(2) NOT NULL,
    views BIGINT(100) UNSIGNED NOT NULL,
    icon INT(1) NOT NULL,
    pollid INT(11) NOT NULL,
    readit BLOB NOT NULL,
    closed INT(1) NOT NULL,
    PRIMARY KEY (topic_id),
    UNIQUE topic_id_2 (topic_id),
    INDEX topic_id (topic_id)
);

# evo_users
DROP TABLE IF EXISTS evo_users;

CREATE TABLE evo_users(
    id INT(11) NOT NULL AUTO_INCREMENT,
    username VARCHAR(255) NOT NULL,
    password VARCHAR(255) NOT NULL,
    rank INT(1) NOT NULL,
    reg_ip VARCHAR(17) NOT NULL,
    reg_date INT(11) NOT NULL,
    ips BLOB NOT NULL,
    num_posts INT(11) NOT NULL,
    email VARCHAR(60) NOT NULL,
    view_email INT(1) NOT NULL,
    icq INT(15) NULL,
    msnm VARCHAR(60) NULL,
    aim VARCHAR(60) NULL,
    interests VARCHAR(200) NULL,
    signiture VARCHAR(250) NULL,
    awards INT(11) NOT NULL,
    lasttime INT(11) NOT NULL,
    views BIGINT(100) UNSIGNED NOT NULL,
    homepage VARCHAR(255) NOT NULL,
    special_title VARCHAR(50) NOT NULL,
    notifytype INT(1) NOT NULL,
    PRIMARY KEY (id)
);

# instantmessages
DROP TABLE IF EXISTS instantmessages;

CREATE TABLE instantmessages(
    hashid VARCHAR(100) NOT NULL,
    username VARCHAR(100) NOT NULL,
    message TEXT NOT NULL,
    msgid BIGINT(50) NOT NULL AUTO_INCREMENT,
    PRIMARY KEY (msgid)
);


INSERT INTO evo_users (id, username, password, rank, reg_ip, reg_date, ips, num_posts, email, view_email, icq, msnm, aim, interests, signiture, awards, lasttime, views, homepage, special_title, notifytype) VALUES (1,'admin','c21f969b5f03d33d43e04f8f136e7682',5,'192.168.1.1',0,'',0,'admin@yourdomain.com',0,NULL,NULL,NULL,NULL,NULL,0,0,0,'','n',1);

