#!/usr/bin/perl

# This is the Cyberbrau installer script.
# it has to options; Install or upgrade.
#
#       Your mileage may vary.

############
# If you have problems w/ the mysql install portion, you may need to 
# set an explicit path to your mysql binaries below
# Just uncomment the following lines, and set the correct pathes


#   $mysql ="/path/to/mysql";
#   $mysqladmin = "/path/to/mysqladmin";


#
# Upgrade should:
#   1) modify the DB
#   2) copy new files
#   3) edit conf file (if necessary)
#
# Install should:
#   1) make a new dir in doc root somewhere
#   2) copy all files to dir
#   3) create CB DB w/ grants given
#   4) populate tables w/ some recipes
#
# mysql -u$dbrootuser -p'$dbrootpasswd'
# mysqladmin create $dbname -u$dbrootuser -p'$dbrootpasswd'
#
# Let us try to find your mysql stuff first...
#
unless ($mysql){
    if ( -e "/usr/local/mysql/bin/mysql"){
    # default install location for linux.
        $mysql ="/usr/local/mysql/bin/mysql";
        $mysqladmin ="/usr/local/mysql/bin/mysqladmin";
    }
    else{
    # look in the path
        @dirs = split(/:/, $ENV{PATH});
            foreach (@dirs){
                if (-e "$_\/mysql"){
                    $mysql = "$_\/mysql";
                    $mysqladmin = "$_\/mysqladmin";
                }
            }
    }
    if (!$mysqladmin){
    # look a little harder
        my $mysqlp = `whereis mysql`;
        $mysqlp =~ s/.*?:\s(.*)/$1/g;
        my @paths = split / /, $mysqlp;
        chomp(@paths);
    #    our ($mysql, $mysqladmin);
        foreach my $path (@paths) {
         "$path/bin/mysql\n";
                if (-x $path && -f $path) {
                        $mysql = $path;
                }
                elsif (-x "$path/bin/mysql" && -f "$path/bin/mysql")  {
                        $mysql = "$path/bin/mysql";
                    $mysqladmin = "$path/bin/mysqladmin" if (-x "$path/bin/mysqladmin" && -f "$path/bin/mysqladmin") ;
            }
        }

    }
}


if (!$mysql){
    print "\n\nI was unable to find your mysql executables.\nIf you have it installed, you can edit this script manually, or add the mysql to your \$PATH\n\n";
    exit;
}

print "\n\nWelcome to the Cyberbrau installer.\n\nWould you like to install or upgrade Cyberbrau? (i/u)";
$inp =  <STDIN>;
    if ($inp =~ /i/i){
        print "\nInstall\n";
        &install;
    }
    elsif ($inp =~ /u/i){
        print "\nUpgrade\n";
        &upgrade;
    }
    else {
        print "\nError!  You must select Install or Upgrade (i/u)\n\n";
    }

sub install(){
    print "\nPlease input the target Docroot (eg. /opt/web/html/cyberbrau )\n\# ";
    $target = <STDIN>;
    chomp($target);

    print "\nWould you like to install the Cyberbrau forum alongside Cyberbrau?\n\# ";
    $mytmp = <STDIN>;
    chomp($mytmp);
    if ($mytmp =~ /y/i){
        $install_forum=1;
        print "Adding forum. \n";
    }

    print "\nPlease input your mysql root user (one that can create DBs)\n\# ";
    $mysqlroot = <STDIN>;
    chomp($mysqlroot);
    print "\nPlease input your mysql root user's password\n\# ";
    $mysqlrootpw = <STDIN>;
    chomp($mysqlrootpw);

    print "\nPlease enter your mysql host\n\#(localhost) ";
    $dbhost = <STDIN>;
    chomp($dbhost);
    if ($dbhost eq "") { $dbhost = "localhost";}

    print "\nPlease enter the Database name for your Cyberbrau DB\n\#(cyberbrau) ";
    $cbname = <STDIN>;
    chomp($cbname);
    if ($cbname eq "") { $cbname = "cyberbrau";}

    print "\nPlease enter a mysql user for your Cyberbrau DB\n\# ";
    $mysqlcb = <STDIN>;
    chomp($mysqlcb);
    print "\nPlease enter a password for your Cyberbrau user\n\# ";
    $mysqlcbpw = <STDIN>;
    chomp($mysqlcbpw);

    print "\nPlease enter the BASE URL for your Cyberbrau site\n\#(e.g.: www.yourdomain.com/cyberbrau or
            www.cyberbrau.org or even 192.168.1.1/cyberbrau) \n\#";
    $basehref = <STDIN>;
    chomp($basehref);
    if ($basehref eq "") { $basehref = "www.cyberbrau.org";}
    

    
        if (!-e $target){
            print "$target does not exist.  \nShall I create it? (y/n) ";
            $createdir = <STDIN>;
            if ($createdir =~ /^n/i){
                print "Ok. exiting.\n";
                exit;
            }
            else{
                $mkdir = `mkdir $target`;
            }
        }

    print "Ok.  copying files...";
    $cp = `cp -rp * $target`;
    print " done\nCreating database(s)...";
    
    $dbcreate = `$mysqladmin create $cbname -u$mysqlroot -p$mysqlrootpw`;
    if($dbcreate != ""){print "Install Failed!\n\n$dbcreate\n"; exit; }
    else{ print"CyberBrau DB created. \n";}

    if ($install_forum){
        $forum_db = "$cbname"."_forum";
        $dbcreate = `$mysqladmin create $forum_db -u$mysqlroot -p$mysqlrootpw`;
        if($dbcreate != ""){print "Install Failed!\n\n$dbcreate\n"; exit; }
        else{ print"CyberBrau FORUM DB created.\n";}

    }
# Normal CB table buildup
    open(SQL,"cb_create.sql");
    @sql = <SQL>;
    close(SQL);

    open(TMP,">tmp.sql");

    $auth =  qq|
        GRANT select, insert, update, delete
        ON $cbname.*
        TO $mysqlcb\@$dbhost
        IDENTIFIED BY '$mysqlcbpw';
    |;
    push (@sql, $auth);

        push(@delfiles, "tmp.sql");

    print TMP @sql;
    close(TMP);


    $doit = system("cat tmp.sql | $mysql -f $cbname -u$mysqlroot -p$mysqlrootpw");
    if ($doit !=0){ print "\nError installing Cyberbrau database ($cbname).\nCheck that the Mysql user \"$mysqlroot\" has sufficient privileges.\n";}

    if ($install_forum){
# FORUM CB table buildup
        open (SQL2,"forum.sql");
        @sql2 = <SQL2>;
        close(SQL2);

        open(TMP2,">tmp2.sql");
        $auth2 = qq|
            GRANT select, insert, update, delete
            ON $forum_db.*
            TO $mysqlcb\@$dbhost
            IDENTIFIED BY '$mysqlcbpw';
        |;
        push (@sql2, $auth2);
        push(@delfiles, "tmp2.sql");

        print TMP2 @sql2;
        close(TMP2);

        $doit = system("cat tmp2.sql | $mysql -f $forum_db -u$mysqlroot -p$mysqlrootpw");
        if ($doit !=0){ 
            print "\nError installing Cyberbrau FORUM database ($forum_db).\n
                Check that the Mysql user \"$mysqlroot\" has sufficient privileges.\n";
        }

    }

### End DB work

    open(CONF,">$target/conf.php")|| die "Could not open $target/conf.php";
    print CONF qq|<?
\$datasource = "$cbname";
\$host = "$dbhost";
\$dbusername = "$mysqlcb";
\$auth ="$mysqlcbpw"; |;
if ($install_forum){
    print CONF qq|\$useforum=1;\n\$forumdb="$forum_db";\n |;
}
print CONF qq|\$bgcolor ="#aec0c9";
\$config ="1";
\$theme = "themes/styleNew.css";
\$admin_ip="192.168.1.1";
\$labels=0;
\$base_href = "http://$basehref";
?>|;
    close(CONF);
#    @delfiles = "tmp.sql";
    unlink @delfiles;
}
sub upgrade(){
        print "\nPlease enter your Cyberbrau path (eg. /opt/web/html/cyberbrau )\n\# ";
        $target = <STDIN>;
        chomp($target);
        if (!-e $target){
            print "Sorry.  The path $target doesnt exist.\n";
            &upgrade;
            exit;
        }
    if (-e "upgrade.sql"){

    print "\nPlease enter the BASE URL for your Cyberbrau site\n";
    print "(e.g.: www.yourdomain.com/cyberbrau or www.cyberbrau.org or even 192.168.1.1/cyberbrau) \n\#";
    $basehref = <STDIN>;
    chomp($basehref);
    if ($basehref eq "") { $basehref = "www.cyberbrau.org";}

    open(CONF,"$target/conf.php")|| die "Could not open $target/conf.php for reading";
    @file = <CONF>;
    close(CONF);

    open(CONF,">$target/conf.php")|| die "Could not open $target/conf.php for writing";
    $newline = qq|\$base_href = "http://$basehref";\n |;
    $tail = splice(@file,-1,1,$newline);
    push(@file,$tail);
    foreach (@file){
        print CONF $_;
    }
    close(CONF);




        print "\nPlease enter your mysql root user (one that can alter your Cyberbaru DB)\n\# ";
        $mysqlroot = <STDIN>;
        chomp($mysqlroot);
        print "\nPlease input your mysql root user's password\n\# ";
        $mysqlrootpw = <STDIN>;
        chomp($mysqlrootpw);

        print "\nPlease enter your mysql host\n\#(localhost) ";
        $dbhost = <STDIN>;
        chomp($dbhost);
        if ($dbhost eq "") { $dbhost = "localhost";}

        print "\nPlease enter the Database name for your Cyberbrau DB\n\#(cyberbrau) ";
        $cbname = <STDIN>;
        chomp($cbname);
        if ($cbname eq "") { $cbname = "cyberbrau";}

        $doit = system("cat upgrade.sql | $mysql -f $cbname -u$mysqlroot -p$mysqlrootpw");
        if ($doit !=0){ print "\n\nError upgrading Cyberbrau database ($cbname).\nDoes \"$mysqlroot\" have priviliges to modify $cbname?\n"; }
        }
        if (-e "upgrade_files"){
            open(TMP,"upgrade_files");
            @lines=<TMP>;
            foreach(@lines){
                chomp($_);
                $blah = system("cp rp $_ $target/");
                if ($blah != 0){ print "Could not copy $_ to $target\n"; }
            }
            print "Done copying files.\n Upgrade complete.\n\n";
        }
        else {
            print "\nSorry, I couldn't find a required file: upgrade_files\nPlease untar the upgrade package again.\n\n";
        }
}
